#!/bin/sh
#
TMPSH=/tmp/esxcli-shell.$$
#
while getopts :c:d:l:e:ai opt; do
   case $opt in
	  c) echo $OPTARG | sed -e 's/\\\(.\)/\1/g' -e 's/^"\(.*\)"$/\1/' -e "s/^'\(.*\)'$/\1/" >>$TMPSH ;;
	  d) wdir=$OPTARG ;;
	  l) logfile=$OPTARG ;;
	  e) errlog=$OPTARG ;;
	  a) appendlog=">" ;;
	  i) about=1 ;;
   esac
done
#
echo "<?xml version=\"1.0\" ?>"
echo "<output xmlns=\"http://www.vmware.com/Products/ESX/5.0/esxcli/\">"
echo -n "<string><![CDATA["
#
if [ "$about" == "1" ]; then
   cat <<EOT

Esxcli Shell plugin v1.1 by
   Andreas Peetz (http://www.v-front.de)

This esxcli plugin allows to run arbitrary ESXi shell commands
through esxcli. For more information see
   http://esxcli-shell.v-front.de

Disclaimer:
   The author of this plugin expressly disclaims any warranty for it.
   The plugin and any related documentation is provided "as is" without
   warranty of any kind, either expressed or implied, including, without
   limitation, the implied warranties or merchantability, fitness for a
   particular purpose, or non-infringement. The entire risk arising out
   of use or performance of the plugin remains with you. In no event shall
   the author of this Software be liable for any damages whatsoever
   (including, without limitation, damages for loss of business profits,
   business interruption, loss of business information, or any other
   pecuniary loss) arising out of the use of or inability to use this
   product, even if the author of this plugin has been advised of the
   possibility of such damages.
EOT
else
   oldPWD="$PWD"
   [ -n "$wdir" ] && cd "$wdir"
   cmd=". $TMPSH"
   [ -n "$logfile" ] && cmd="$cmd >$appendlog\"$logfile\""
   if [ -n "$errlog" ]; then
      cmd="$cmd 2>$appendlog\"$errlog\""
   else
      cmd="$cmd 2>&1"
   fi
   cat $TMPSH | logger -t "shell[$$]: [${VI_USERNAME} via esxcli]"
   ( eval $cmd ) 2>&1 || true
   cd "$oldPWD"
   rm -f $TMPSH
fi
echo "]]></string>"
echo "</output>"